#include "chdecl.h"
void CH_codegen_clauseusesobj(current, sched, cop)
#define ARGUMENTS 5
#include "chhead.h"
select: switch (SELECTOR) {
    case 0: goto c0;
    case 1: goto cb2;
    case 2: goto c3;
    case 3: goto c6;
    case 4: goto c9;
    case 5: goto c19;
    case 6: goto c32;
    case 7: goto c35;
    case 8: goto c38;
    case 9: goto c45;
    case 10: goto c47;  }
c0:
/* block , 0 */
  if((ch_returncode = che_block(QUAL(0),sched)) != Normal)
     goto ch_raise_exception;
/* block , 1 */
  if((ch_returncode = che_block(QUAL(1),sched)) != Normal)
     goto ch_raise_exception;
  current->ip = 1;
cb2:
/* receive 3 0 */
  if ((ch_returncode = che_receive(DEF(3),DEF(0),sched)) != Normal)
     goto ch_raise_exception;
  return;
c3:
/* find 4 3.2.4.0.1.1 3.0 , 0 */
  if (findfunc(DEF(4),DEF(3)DOT(2)DOT(4)DOT(0)DOT(1)DOT(1),(
          arguments[0] = DEF(3)DOT(0),& arguments[0]),sched,0) == FAILURE)
             goto ch_notfound;
/* copy 5 4.1 */
  if((ch_returncode = cp_table(& ch_val, REF(4)DOT(1).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(5).tsdr)->finalize)(REF(5).value,F_DISCARD,sched);
  REF(5).value = ch_val;
  REF(5).tsdr = & dr_table;
/* initget 6 5 , 0,0 */
  (*(REF(6).tsdr)->finalize)(REF(6).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(6),DEF(5),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c6:
/* get_or_goto 6 5 , 38 */
  if ((ch_returncode = get_selected_object(DEF(6),DEF(5),sched)) != Normal)
     goto c38;
/* copy 7 6.2 */
  if((ch_returncode = cp_table(& ch_val, REF(6)DOT(2).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(7).tsdr)->finalize)(REF(7).value,F_DISCARD,sched);
  REF(7).value = ch_val;
  REF(7).tsdr = & dr_table;
/* initget 8 7 , 0,0 */
  (*(REF(8).tsdr)->finalize)(REF(8).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(8),DEF(7),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c9:
/* get_or_goto 8 7 , 35 */
  if ((ch_returncode = get_selected_object(DEF(8),DEF(7),sched)) != Normal)
     goto c35;
/* block , 2 */
  if((ch_returncode = che_block(QUAL(2),sched)) != Normal)
     goto ch_raise_exception;
/* equal 9 8.0 3.1.0 */
  REF(9).value.boolean = ((REF(8)DOT(0).tsdr->equal)(REF(8)DOT(0).value,
    REF(3)DOT(1)DOT(0).value));
  REF(9).tsdr = & dr_boolean;
/* size 10 3.1.1 */
  REF(10).value.integer = REF(3)DOT(1)DOT(1).value.table->size;
  REF(10).tsdr = & dr_integer;
/* size 11 8.1 */
  REF(11).value.integer = REF(8)DOT(1).value.table->size;
  REF(11).tsdr = & dr_integer;
/* ile 12 10 11 */
  REF(12).value.boolean = (REF(10).value.integer <= REF(11).value.integer);
/* and 13 9 12 */
  REF(13).value.boolean = REF(9).value.boolean&REF(12).value.boolean;
  REF(13).tsdr = & dr_boolean;
/* branch_false 13 , 32 */
  if ( !REF(13).value.boolean ) goto c32;
/* copy 14 3.1.1 */
  if((ch_returncode = cp_table(& ch_val, REF(3)DOT(1)DOT(1).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(14).tsdr)->finalize)(REF(14).value,F_DISCARD,sched);
  REF(14).value = ch_val;
  REF(14).tsdr = & dr_table;
/* initget 15 14 , 0,0 */
  (*(REF(15).tsdr)->finalize)(REF(15).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(15),DEF(14),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c19:
/* get_or_goto 15 14 , 26 */
  if ((ch_returncode = get_selected_object(DEF(15),DEF(14),sched)) != Normal)
     goto c26;
/* position 16 15 */
  ch_frame = get_selector_frame(DEF(15),sched);
  ch_t = ch_frame->inspectee->value.table;
  REF(16).value.integer = ch_frame->rmvcount +
    (*(ch_t->tbls[ORDER_TBL].des->position_of))(ch_t,ORDER_TBL,ch_frame->pos);
  REF(16).tsdr = &dr_integer;
/* lookup_at 17 8.1 16 */
  if((ch_i = REF(16).value.integer) < 0 || ch_i >= (ch_t = REF(8)DOT(1).value
    .table)->size) goto ch_notfound;
  (*(REF(17).tsdr)->finalize)(REF(17).value,F_DISCARD,sched);
  (*(ch_t->tbls[ORDER_TBL].des->lookup_at))
    (ch_t, ORDER_TBL, & REF(17).value,ch_i);
  REF(17).tsdr = qdatarepmap[ch_t->tsdr->number];
/* equal . 15 17 , 19 */
  if ( (REF(15).tsdr->equal)(REF(15).value,REF(17).value) ) goto c19;
/* exit , 3 */
  ch_e = handler_type__exit; ch_val = QUAL(3); goto ch_exception;
c26:
/* endget 15 14 */
  end_selector(DEF(15),DEF(14),sched,GET);
/* discard 14 */
  (*(REF(14).tsdr)->finalize)(REF(14).value,F_DISCARD,sched);
  REF(14).tsdr = & dr_bottom;
/* boolean 3.3 , TRUE */
  REF(3)DOT(3).value.boolean = TRUE;
  REF(3)DOT(3).tsdr = & dr_boolean;
/* return 3 */
  if (ch_caller = do_return(REF(3).value)) {
    if (ch_caller->type < CProcess) ch_caller->ip++;
      sched->wakeup_proc(sched, ch_caller);}
  else rem_return(REF(3).value);
  REF(3).tsdr = & dr_bottom;
/* exit , 4 */
  ch_e = handler_type__exit; ch_val = QUAL(4); goto ch_exception;
c32:
/* endblock */
  che_endblock(sched);
/* branch , 9 */
   goto c9;
c35:
/* endget 8 7 */
  end_selector(DEF(8),DEF(7),sched,GET);
/* discard 7 */
  (*(REF(7).tsdr)->finalize)(REF(7).value,F_DISCARD,sched);
  REF(7).tsdr = & dr_bottom;
/* branch , 6 */
   goto c6;
c38:
/* endget 6 5 */
  end_selector(DEF(6),DEF(5),sched,GET);
/* discard 5 */
  (*(REF(5).tsdr)->finalize)(REF(5).value,F_DISCARD,sched);
  REF(5).tsdr = & dr_bottom;
/* boolean 3.3 , FALSE */
  REF(3)DOT(3).value.boolean = FALSE;
  REF(3)DOT(3).tsdr = & dr_boolean;
/* return 3 */
  if (ch_caller = do_return(REF(3).value)) {
    if (ch_caller->type < CProcess) ch_caller->ip++;
      sched->wakeup_proc(sched, ch_caller);}
  else rem_return(REF(3).value);
  REF(3).tsdr = & dr_bottom;
/* endblock */
  che_endblock(sched);
c45:
/* endblock */
  che_endblock(sched);
c47:
/* endprocess */
  che_endprocess(sched); return;
#include "chtail.h"
